﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BinHeapArray
{
    class Program
    {
        static void Main(string[] args)
        {
            MinBinaryHeapArray<BinaryTreeNode> bHA = new MinBinaryHeapArray<BinaryTreeNode>();

            BinaryTreeNode[] input = {
                new BinaryTreeNode(12),
                new BinaryTreeNode(9), 
                new BinaryTreeNode(14), 
                new BinaryTreeNode(10), 
                new BinaryTreeNode(11), 
                new BinaryTreeNode(9), 
                new BinaryTreeNode(4), 
                new BinaryTreeNode(1), 
                new BinaryTreeNode(2), 
                new BinaryTreeNode(9), 
                new BinaryTreeNode(15), 
                new BinaryTreeNode(5) };

            for (int i = 0; i < input.Length; i++)
            {
                Console.Write("{0}, ", input[i].Key);
                bHA.Add(input[i]);
            }
            Console.WriteLine();
            Console.WriteLine();


            bHA.levelorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.inorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.preorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.postorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();

            while (bHA.CountNode > 0)
            {
                Console.WriteLine(bHA.ExtractMin().Key.ToString()); 
            }

            bHA = new MinBinaryHeapArray<BinaryTreeNode>(input);

            bHA.levelorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.inorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.preorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();
            bHA.postorder(MinBinaryHeapArray<BinaryTreeNode>.rootIdx);
            Console.WriteLine();

            while (bHA.CountNode > 0)
            {
                Console.WriteLine(bHA.ExtractMin().Key.ToString());
            }
            
            Console.ReadLine();
        }
    }
}
